// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.Any;

public interface IndexManager {

	// managing frame indices
	public AnyArray getFrameIndex(AnyString key);
	public AnyArray getFrameIndex(String key);
	public void addFrameIndex(AnyString indexName);
	public void addFrameIndex(String indexName);
	public void removeFrameIndex(AnyString indexName);
	public void removeFrameIndex(String indexName);	
	
	// managing other indices
	public AnyArray getIndex(AnyString indexName);
	public AnyArray getIndex(String indexName);
	public void addIndex(AnyString indexName, AnyArray index);
	public void addIndex(String indexName, AnyArray index);
	public void removeIndex(AnyString indexName);
	public void removeIndex(String indexName);

	// enrolling / unrolling	(only to/from frame indices)
	public void enroll(AnyFrame anAnyFrame);
	public void unroll(AnyFrame anAnyFrame);

	// printing 
	public void printStatistics();	// to System.out
	
	// misc
	public IndexManager duplicateWithSettings();
	
}
