// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.Any;
import Geo.Framework.Any.AnyBoolean;



public class AnyBooleanImpl extends AnyImpl implements AnyBoolean {

	// class variables
	
	protected static AnyBoolean trueObject;
	protected static AnyBoolean falseObject;
	
	
	// static initialization
	
	static {
		trueObject = new AnyBooleanImpl(true);
		falseObject = new AnyBooleanImpl(false);	
	}
	
	
	// instance variables
	
	protected boolean value;


	// constructors
	
	protected AnyBooleanImpl(boolean b) {
		value = b;
	}
	
	
	// accessing value
	
	public boolean asBoolean() {
		return value;
	}
	
	public int asInteger() {
		return value ? 1 : 0;
	}
	
	
	// comparing
	
	public boolean isEqual(boolean b) {
		return asBoolean() == b;
	}	

	public boolean notEqual(boolean b) {
		return !isEqual(b);
	}	

	
	// copying

	public Any shallowCopy() {
		return this;
	}	
	
	public Any deepCopy() {
		return this;
	}


	// testing
	
	public boolean isValueType() {
		return true;
	}

	
	// printing
	
	public String toString() {
		return String.valueOf(value);
	}
	
}
