// Copyright 1997 Ubilab, Union Bank of Switzerland. All rights reserved.
// This is part of the Geo system developed by Ubilab's DistrOOSE group.
// Check out: http://www.ubs.com/ubilab/Projects/se/se.html. GLAB-REH-97.

package Geo.Framework.AnyImpl;

import Geo.Framework.Any.Any;
import Geo.Framework.Any.AnyInteger;



public class AnyIntegerImpl extends AnyImpl implements AnyInteger {

	// instance variables

	protected int value;


	// constructors
	
	protected AnyIntegerImpl(int i) {
		value = i;
	}
	
	
	// accessing value

	public int asInteger() {  
		return value;
	}
	
	// comparing

	public boolean isEqual(int i) {
		return value == i;
	}

	public boolean notEqual(int i) {
		return !isEqual(i);
	}
		
	public boolean isEqual(Any anAny) {
		return anAny != null 
			&& anAny instanceof AnyInteger 
			&& anAny.asInteger() == value;
	}	
	
	public int hashCode() {
		return value;
	}


	// testing
	
	public boolean isValueType() {
		return true;
	}


	// printing 
	
	public String toString() {
		return String.valueOf(value);
	}
	
}
